from enum import Enum
from datetime import datetime
from application import db, ma
from sqlalchemy import asc
from marshmallow import Schema, fields


class MovieRating(db.Model):
    __tablename__ = 'imdb_db_ratings'
    imdb_db_title_id = db.Column(db.String(200),primary_key=True, autoincrement=True)
    weighted_average_vote = db.Column(db.Float(), unique=True, nullable=False)
    total_votes = db.Column(db.Float(), default=0.0)
    mean_vote = db.Column(db.Float(), nullable=False)
    median_vote = db.Column(db.Integer(), default=0)
    votes_10 = db.Column(db.Integer(), default=0)
    votes_9 = db.Column(db.Integer(), default=0)
    votes_8 = db.Column(db.Integer(), default=0)
    votes_7 = db.Column(db.Integer(), default=0)
    votes_6 = db.Column(db.Integer(), default=0)
    votes_5 = db.Column(db.Integer(), default=0)
    votes_4 = db.Column(db.Integer(), default=0)
    votes_3 = db.Column(db.Integer(), default=0)
    votes_2 = db.Column(db.Integer(), default=0)
    votes_1 = db.Column(db.Integer(), default=0)
    allgenders_0age_avg_vote = db.Column(db.Float(), default=0)
    allgenders_0age_votes = db.Column(db.Integer(), default=0)
    allgenders_18age_avg_vote = db.Column(db.Integer(), default=0)
    allgenders_18age_votes = db.Column(db.Integer(), default=0)
    allgenders_30age_avg_vote = db.Column(db.Integer(), default=0)
    allgenders_30age_votes = db.Column(db.Integer(), default=0)
    allgenders_45age_avg_vote = db.Column(db.Integer(), default=0)
    allgenders_45age_votes = db.Column(db.Integer(), default=0)
    males_allages_avg_vote = db.Column(db.Integer(), default=0)
    males_allages_votes = db.Column(db.Integer(), default=0)
    males_0age_avg_vote = db.Column(db.Integer(), default=0)
    males_0age_votes = db.Column(db.Integer(), default=0)
    males_18age_avg_vote = db.Column(db.Integer(), default=0)
    males_18age_votes = db.Column(db.Integer(), default=0)
    males_30age_avg_vote = db.Column(db.Integer(), default=0)
    males_30age_votes = db.Column(db.Integer(), default=0)
    males_45age_avg_vote = db.Column(db.Integer(), default=0)
    males_45age_votes = db.Column(db.Integer(), default=0)
    females_allages_avg_vote = db.Column(db.Integer(), default=0)
    females_allages_votes = db.Column(db.Integer(), default=0)
    females_0age_avg_vote = db.Column(db.Integer(), default=0)
    females_0age_votes = db.Column(db.Integer(), default=0)
    females_18age_avg_vote = db.Column(db.Integer(), default=0)
    females_18age_votes = db.Column(db.Integer(), default=0)
    females_30age_avg_vote = db.Column(db.Integer(), default=0)
    females_30age_votes = db.Column(db.Integer(), default=0)
    females_45age_avg_vote = db.Column(db.Integer(), default=0)
    females_45age_votes = db.Column(db.Integer(), default=0)
    top1000_voters_rating = db.Column(db.Integer(), default=0)
    top1000_voters_votes = db.Column(db.Integer(), default=0)
    us_voters_rating = db.Column(db.Integer(), default=0)
    us_voters_votes = db.Column(db.Integer(), default=0)
    non_us_voters_rating = db.Column(db.Integer(), default=0)
    non_us_voters_votes  = db.Column(db.Integer(), default=0)

    def __repr__(self):
        return '<ratings: {}>'.format(self.imdb_db_title_id)


class MovieRatingSchema(ma.Schema):
    imdb_title_id = fields.String()
    weighted_average_vote = fields.String()
    total_votes = fields.Float()
    mean_vote = fields.Float()
    median_vote = fields.Integer()
    votes_10 = fields.Integer()
    votes_9 = fields.Integer()
    votes_8 = fields.Integer()
    votes_7 = fields.Integer()
    votes_6 = fields.Integer()
    votes_5 = fields.Integer()
    votes_4 = fields.Integer()
    votes_3 = fields.Integer()
    votes_2 = fields.Integer()
    votes_1 = fields.Integer()
    allgenders_0age_avg_vote = fields.Float()
    allgenders_0age_votes = fields.Integer()
    allgenders_18age_avg_vote = fields.Float()
    allgenders_18age_votes = fields.Integer()
    allgenders_30age_avg_vote = fields.Integer()
    allgenders_30age_votes = fields.Integer()
    allgenders_45age_avg_vote = fields.Integer()
    allgenders_45age_votes = fields.Integer()
    males_allages_avg_vote = fields.Integer()
    males_allages_votes = fields.Integer()
    males_0age_avg_vote = fields.Integer()
    males_0age_votes = fields.Integer()
    males_18age_avg_vote = fields.Integer()
    males_18age_votes = fields.Integer()
    males_30age_avg_vote = fields.Integer()
    males_30age_votes = fields.Integer()
    males_45age_avg_vote = fields.Integer()
    males_45age_votes = fields.Integer()
    females_allages_avg_vote = fields.Integer()
    females_allages_votes = fields.Integer()
    females_0age_avg_vote = fields.Integer()
    females_0age_votes = fields.Integer()
    females_18age_avg_vote = fields.Integer()
    females_18age_votes = fields.Integer()
    females_30age_avg_vote = fields.Integer()
    females_30age_votes = fields.Integer()
    females_45age_avg_vote = fields.Integer()
    females_45age_votes = fields.Integer()
    top1000_voters_rating = fields.Integer()
    top1000_voters_votes = fields.Integer()
    us_voters_rating = fields.Integer()
    us_voters_votes = fields.Integer()
    non_us_voters_rating = fields.Integer()
    non_us_voters_votes = fields.Integer()